def proc display_grid
rem display the grid, for each line in turn, show the corresponding
rem sprite at each column
local lines%,columns%,lp2%,xo%,yo%,my_sprite,t%
  xorig%=(xsize%-(gxs%*sp_size%)-8) DIV 2      : rem centre
  yorig%=(ysize%-(gys%*sp_size%)-20) DIV 2     : rem global var
  yo%=yorig%
  for lines%=1 to gys%
    xo%=xorig%			: rem restart at first column
    for columns%= 1 to gxs%
      t%=grid%(lines%,columns%) : rem what kind of sprite to display?
      select on t%
	=0: my_sprite=empty_sprite
	=2: my_sprite=wall_sprite
	=4: my_sprite=box_sprite
	=8: my_sprite=boden_sprite
	=16: my_sprite=target_sprite
	=20: my_sprite=tnb_sprite : rem 20=16+4: box over target
	=32: my_sprite=man_sprite : rem this should never happen!
	=remainder:my_sprite=0
      end select
      if my_sprite=box_sprite:	Wsprt#mnch%,xo%,yo%,boden_sprite
      Wsprt#mnch%,xo%,yo%,my_sprite
      xo%=xo%+sp_size%		: rem move one column to the left
    end for columns%		: rem do for all comlumns
    yo%=yo%+sp_size%		: rem move one line further down
  end for lines%		: rem do for all lines
  display_man			: rem display the 'man'
end def display_grid
:
def proc display_man
rem this displays the "man" at its coords
local xo%,yo%
  xo%=xorig%+((man%(0)-1)*sp_size%)   : rem now show "man"
  yo%=yorig%+((man%(1)-1)*sp_size%)
  if grid%(man%(1),man%(0))=16
    Wsprt#mnch%,xo%,yo%,mnt_sprite
  else
    Wsprt#mnch%,xo%,yo%,man_sprite
  endif
end def display_man
:
def proc display_square(x%,y%)
rem this displays the sprite at one point in the grid
local xo%,yo%,t%,my_sprite
  xo%=xorig%+((x%-1)*sp_size%)		      : rem now show
  yo%=yorig%+((y%-1)*sp_size%)
  t%=grid%(y%,x%)			: rem what kind of sprite to display?
  select on t%
      =0: my_sprite=empty_sprite
      =2: my_sprite=wall_sprite
      =4: my_sprite=box_sprite
      =8: my_sprite=boden_sprite
      =16: my_sprite=target_sprite
      =20: mu_sprite=tnb_sprite : rem 20=16+4: box over target
      =32: my_sprite=man_sprite : rem this should never happen!
  end select
  Wsprt#mnch%,xo%,yo%,my_sprite
end def display_square
:
def proc shift_box(xold%,yold%,x%,y%)
rem this "moves" a box from the old coords to the new coords
rem the old coords are either a simple box or a box over target
rem new coords are either a target or a boden
local xo%,yo%,t%,my_sprite
  t%=grid%(yold%,xold%) 	: rem what kind of sprite?
  select on t%
      =4: my_sprite=boden_sprite
	grid%(yold%,xold%)=8	: rem was simple box, becomes "boden"
      =20: my_sprite=target_sprite	: rem 20=16+4: box over target
	grid%(yold%,xold%)=16	: rem reset to simple target
  end select
:
  xo%=xorig%+((x%-1)*sp_size%)
  yo%=yorig%+((y%-1)*sp_size%)
  t%=grid%(y%,x%)			: rem what kind of sprite?
  select on t%
      =8: my_sprite=box_sprite
	grid%(y%,x%)=4		: rem was "boden", becomes simple box
      =16: my_sprite=tnb_sprite : rem 20=16+4: box over target
	grid%(y%,x%)=20 	: rem reset to box over target
  end select
  Wsprt#mnch%,xo%,yo%,my_sprite
end def shift_box
:
