def proc init
rem intialises variables, either directly or indirectly, sets up grid
rem and displays it
local xo%,yo%
  dim grid%(10,10),undo%(10,10) : rem displayed grid and undo for it
  dim man%(1),undo_man%(1)	: rem x,y coords of man
  dim grids%(1,1,1)		: rem array with all grids
  dim grid_sizes%(1,2)		: rem y,x sizes of grids
  xsize%=504			: rem wdw xsize
  ysize%=250			: rem
  min_xsize%=xsize%
  min_ysize%=ysize%
  sp_size%=20			: rem sprite size
:
  max_lines%=(ysize%-18) div sp_size% : rem max number of lines I can display
  max_cols%=(xsize%-10) div sp_size% : rem max nbr of columns I can display
  moves%=0
  maxpuzzle%=0			: rem max nbr of puzzles
  menu_ink%=0:menu_pap%=7:menu_brd%=2
  puzzle%=1			: rem currently played puzzle
  my_language			: rem get language dependent texts
  read_sprites
  read_all_grids 50
  read_grid  puzzle%-1		: rem read initial grid
  level$=levelprim$&maxpuzzle%&")"
  init_wdw
  if is_extn("HOME_DIR$")
     importfile$=home_dir$&"81_slc"
  else
    if is_extn("PROGD$")
      importfile$=progd$&"81_slc"
    else
	importfile$="nfa1_81.slc"
    endif
  endif
  warn_make	:	rem make warning definition
  main_menu_defn=menus_init_menu (main_menu_title$,main_menu$,main_menu_selkeys$)
end def init
:
def proc set_info_wdw (clear%)
local yof%(3),a$,xs%
  dr_iwdf#mnch%,main_defn,0
  if clear%
    wm_paper#mnch%,sp.titlebg
    cls#mnch%
  endif
  wm_ink#mnch%,sp.titlefg
  wm_paper#mnch%,sp.infwinbg
  wsipo#mnch%,yof%
  a$="  SoQLBan "&menu_bar$&puzzle%&"/"&maxpuzzle%&"    "&moves$&moves%&"  "
  xs%=len(a$)*6
  xs%=(yof%(0)-xs%)/2
  cursor#mnch%,xs%,1
  print #mnch%,a$
end def set_info_wdw
:
def proc set_app_wdw (clear%)
local yof%
  dr_awdf#mnch%,main_defn,0
  wm_paper#mnch%,sp.appbg
  wm_ink#mnch%,sp.appfg
  if clear%
    cls#mnch%
    display_grid
  endif
end def set_app_wdw
:
